package com.ejie.ab79.control;

import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import org.springframework.web.bind.annotation.SessionAttributes;

import com.ejie.ab79.clientesWS.ab61WebService.Usuario;
import com.ejie.ab79.model.actuaciones.DesResAct;
import com.ejie.ab79.model.actuaciones.ResultadosActuacion;
import com.ejie.ab79.service.actuaciones.ResultadosActuacionService;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ResultadosActuacionController  
 * 
 *  
 */
@SessionAttributes("usuario")
@Controller
@RequestMapping(value = "/resultadosactuacion")

public class ResultadosActuacionController {

	private static final Logger logger = LoggerFactory.getLogger(ResultadosActuacionController.class);

	@Autowired
	private ResultadosActuacionService resultadosActuacionService;

	/*
	 * OPERACIONES CRUD (Create, Read, Update, Delete)
	 * 
	 */

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idResultadoActuacion
	 *            Long
	 * @return ResultadosActuacion Objeto correspondiente al identificador
	 *         indicado.
	 */
	@RequestMapping(value = "/{idResultadoActuacion}", method = RequestMethod.GET)
	public @ResponseBody ResultadosActuacion get(@PathVariable Long idResultadoActuacion) {
		ResultadosActuacion resultadosActuacion = new ResultadosActuacion();
		resultadosActuacion.setIdResultadoActuacion(idResultadoActuacion);
		resultadosActuacion = this.resultadosActuacionService.find(resultadosActuacion);
		ResultadosActuacionController.logger.info("[GET - findBy_PK] : Obtener ResultadosActuacion por PK");
		return resultadosActuacion;
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterResultadosActuacion
	 *            ResultadosActuacion Objeto que contiene los parametros de
	 *            filtrado utilizados en la busqueda.
	 * @return List<ResultadosActuacion> Lista de objetos correspondientes a la
	 *         busqueda realizada.
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody List<ResultadosActuacion> getAll(
			@ModelAttribute ResultadosActuacion filterResultadosActuacion) {
		ResultadosActuacionController.logger.info("[GET - find_ALL] : Obtener ResultadosActuacion por filtro");
		return this.resultadosActuacionService.findAll(filterResultadosActuacion, null);
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterResultadosActuacion
	 *            ResultadosActuacion Objeto que contiene los parametros de
	 *            filtrado utilizados en la busqueda.
	 * @return List<ResultadosActuacion> Lista de objetos correspondientes a la
	 *         busqueda realizada.
	 */
	@RequestMapping(value = "addModalResultadosActuacion/{idInspeccion}", method = RequestMethod.GET)
	public @ResponseBody List<ResultadosActuacion> addModalResultadosActuacion(
			@ModelAttribute ResultadosActuacion filterResultadosActuacion, @PathVariable Integer idInspeccion) {
		ResultadosActuacionController.logger.info("[GET - find_ALL] : Obtener ResultadosActuacion por filtro");
		filterResultadosActuacion.setIdInspeccion(idInspeccion);
		return this.resultadosActuacionService.findAll(filterResultadosActuacion, null);
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterResultadosActuacion
	 *            ResultadosActuacion Objeto que contiene los parametros de
	 *            filtrado utilizados en la busqueda.
	 * @return List<ResultadosActuacion> Lista de objetos correspondientes a la
	 *         busqueda realizada.
	 */
	@RequestMapping(value = "editModalResultadosActuacion/{idResultadoActuacion}/{idInspeccion}", method = RequestMethod.GET)
	public @ResponseBody List<ResultadosActuacion> editModalResultadosActuacion(
			@ModelAttribute ResultadosActuacion filterResultadosActuacion, @PathVariable Long idResultadoActuacion,
			@PathVariable Integer idInspeccion) {
		ResultadosActuacionController.logger.info("[GET - find_ALL] : Obtener ResultadosActuacion por filtro");

		ResultadosActuacion resultadoActuacion = new ResultadosActuacion();

		resultadoActuacion.setIdResultadoActuacion(idResultadoActuacion);
		resultadoActuacion = this.resultadosActuacionService.find(resultadoActuacion);

		filterResultadosActuacion.setIdResultadoActuacion(null);
		filterResultadosActuacion.setIdInspeccion(idInspeccion);

		List<ResultadosActuacion> resultadosActuacion = this.resultadosActuacionService
				.findAll(filterResultadosActuacion, null);

		Boolean existe = null;

		if (resultadosActuacion.size() != 0) {
			for (ResultadosActuacion resultadosActuacionAux : resultadosActuacion) {
				if (resultadosActuacionAux
						.getIdResultadoActuacion() == (resultadoActuacion.getIdResultadoActuacion())) {
					existe = true;
					break;
				} else {
					existe = false;
				}
			}

			if (!existe) {
				if (resultadoActuacion != null && resultadoActuacion.getIdResultadoActuacion() != null
						&& resultadoActuacion.getIdResultadoActuacion() != 0) {
					resultadosActuacion.add(resultadoActuacion);
				}
			}
		} else {
			if (resultadoActuacion != null && resultadoActuacion.getIdResultadoActuacion() != null
					&& resultadoActuacion.getIdResultadoActuacion() != 0) {
				resultadosActuacion.add(resultadoActuacion);
			}
		}

		return resultadosActuacion;
	}

	/**
	 * Operacion CRUD Edit. Modificacion del bean indicado.
	 *
	 * @param resultadosActuacion
	 *            ResultadosActuacion Bean que contiene la informacion a
	 *            modificar.
	 * @return ResultadosActuacion Bean resultante de la modificacion.
	 */
	@RequestMapping(method = RequestMethod.PUT)
	public @ResponseBody ResultadosActuacion edit(@RequestBody ResultadosActuacion resultadosActuacion,
			@ModelAttribute("usuario") Usuario usuario) {

		resultadosActuacion.setUsuarioUltmodificacion(usuario.getUsuario());

		ResultadosActuacion resultadosActuacionAux = this.resultadosActuacionService.update(resultadosActuacion);
		ResultadosActuacionController.logger.info("[PUT] : ResultadosActuacion actualizado correctamente");
		return resultadosActuacionAux;
	}

	/**
	 * Operacion CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 *
	 * @param resultadosActuacion
	 *            ResultadosActuacion Bean que contiene la informacion con la
	 *            que se va a crear el nuevo registro.
	 * @return ResultadosActuacion Bean resultante del proceso de creacion.
	 */
	@RequestMapping(method = RequestMethod.POST)
	public @ResponseBody ResultadosActuacion add(@RequestBody ResultadosActuacion resultadosActuacion,
			@ModelAttribute("usuario") Usuario usuario) {

		resultadosActuacion.setUsuarioRegistro(usuario.getUsuario());

		ResultadosActuacion resultadosActuacionAux = this.resultadosActuacionService.add(resultadosActuacion);
		ResultadosActuacionController.logger.info("[POST] : ResultadosActuacion insertado correctamente");
		return resultadosActuacionAux;
	}

	/**
	 * Operacion CRUD Delete. Borrado del registro correspondiente al
	 * identificador especificado.
	 *
	 * @param idResultadoActuacion
	 *            Long Identificador del objeto que se desea eliminar.
	 * @return ResultadosActuacion Bean eliminado.
	 */
	@RequestMapping(value = "/{idResultadoActuacion}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody ResultadosActuacion remove(@PathVariable Long idResultadoActuacion,
			@ModelAttribute("usuario") Usuario usuario) {
		ResultadosActuacion resultadosActuacion = new ResultadosActuacion();
		resultadosActuacion.setIdResultadoActuacion(idResultadoActuacion);
		resultadosActuacion.setUsuarioUltmodificacion(usuario.getUsuario());
		this.resultadosActuacionService.remove(resultadosActuacion);
		ResultadosActuacionController.logger.info("[DELETE] : ResultadosActuacion borrado correctamente");
		return resultadosActuacion;
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE
	 * 
	 */

	/**
	 * Metodo de presentacion del RUP_TABLE.
	 * 
	 * @param model
	 *            Model
	 * @return String
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.GET)
	public String getFormEdit(Model model) {
		ResultadosActuacionController.logger.info("[GET - View] : resultadosactuacion");
		return "resultadosactuacion";
	}

	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterResultadosActuacion
	 *            ResultadosActuacion Bean que contiene los parametros de
	 *            filtrado a emplear.
	 * @param tableRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<ResultadosActuacion> Dto que contiene el
	 *         resultado del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<ResultadosActuacion> filter(
			@RequestJsonBody(param = "filter") ResultadosActuacion filterResultadosActuacion,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ResultadosActuacionController.logger.info("[POST - filter] : Obtener ResultadosActuacions");
		return this.resultadosActuacionService.filter(filterResultadosActuacion, tableRequestDto, false);
	}

	/**
	 * Operacion de busqueda del componente RUP_TABLE.
	 * 
	 * @param filterResultadosActuacion
	 *            ResultadosActuacion Bean que contiene los parametros de
	 *            filtrado a emplear.
	 * @param searchResultadosActuacion
	 *            ResultadosActuacion Bean que contiene los parametros de
	 *            busqueda a emplear.
	 * @param tableRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en la bÃºsqueda.
	 * @return TableRowDto<ResultadosActuacion> Dto que contiene el resultado de
	 *         la busqueda realizada por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/search", method = RequestMethod.POST)
	public @ResponseBody List<TableRowDto<ResultadosActuacion>> search(
			@RequestJsonBody(param = "filter") ResultadosActuacion filterResultadosActuacion,
			@RequestJsonBody(param = "search") ResultadosActuacion searchResultadosActuacion,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ResultadosActuacionController.logger.info("[POST - search] : Buscar ResultadosActuacions");
		return this.resultadosActuacionService.search(filterResultadosActuacion, searchResultadosActuacion,
				tableRequestDto, false);
	}

	/**
	 * Borrado multiple de registros
	 * 
	 * @param filterResultadosActuacion
	 *            ResultadosActuacion Bean que contiene los parametros de
	 *            filtrado a emplear.
	 * @param tableRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en la busqueda.
	 * @return List<String> Lista de los identificadores de los registros
	 *         eliminados.
	 * 
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody List<String> removeMultiple(
			@RequestJsonBody(param = "filter") ResultadosActuacion filterResultadosActuacion,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ResultadosActuacionController.logger
				.info("[POST - search] : [POST - removeMultiple] : Eliminar multiples ResultadosActuacions");
		this.resultadosActuacionService.removeMultiple(filterResultadosActuacion, tableRequestDto, false);
		ResultadosActuacionController.logger.info("All entities correctly deleted!");

		return tableRequestDto.getMultiselection().getSelectedIds();
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE - JERARQUIA
	 */

	/**
	 * Operacion de filtrado del componente RUP_TABLE para presentar los
	 * registros mediante visualizacion jerarquica.
	 * 
	 * @param filterResultadosActuacion
	 *            ResultadosActuacion Bean que contiene los parametros de
	 *            filtrado a emplear.
	 * @param tableRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<JerarquiaDto<ResultadosActuacion>> Dto que
	 *         contiene el resultado del filtrado realizado por el componente
	 *         RUP_TABLE.
	 */
	@RequestMapping(value = "/jerarquia/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<JerarquiaDto<ResultadosActuacion>> jerarquia(
			@RequestJsonBody(param = "filter") ResultadosActuacion filterResultadosActuacion,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ResultadosActuacionController.logger.info("[POST - jerarquia] : Obtener ResultadosActuacions jerarquia");
		return this.resultadosActuacionService.jerarquia(filterResultadosActuacion, tableRequestDto, false);
	}

	/**
	 * Recupera los hijos de los registros desplegados en la visualizacion
	 * jerarquica.
	 * 
	 * @param filterResultadosActuacion
	 *            ResultadosActuacion Bean que contiene los parametros de
	 *            filtrado a emplear.
	 * @param tableRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<JerarquiaDto<ResultadosActuacion>> Dto que
	 *         contiene el resultado del filtrado realizado por el componente
	 *         RUP_TABLE.
	 */
	@RequestMapping(value = "/jerarquiaChildren", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<JerarquiaDto<ResultadosActuacion>> jerarquiaChildren(
			@RequestJsonBody(param = "filter") ResultadosActuacion filterResultadosActuacion,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ResultadosActuacionController.logger
				.info("[POST - jerarquia] : Obtener ResultadosActuacions jerarquia - Hijos");
		return this.resultadosActuacionService.jerarquiaChildren(filterResultadosActuacion, tableRequestDto);
	}

	/**
	 * EXPORTERS
	 */

	@RequestMapping(value = "/clipboardReport", method = RequestMethod.POST)
	protected @ResponseBody List<ResultadosActuacion> getClipboardReport(
			@RequestJsonBody(param = "filter") ResultadosActuacion filterResultadosActuacion,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ResultadosActuacionController.logger.info("[POST - clipboardReport] : : Copiar multiples usuarios");
		return this.resultadosActuacionService.getMultiple(filterResultadosActuacion, tableRequestDto, false);
	}

	/**
	 * Operacion que busca si existe un registro duplicado.
	 * 
	 * @param idOrigen
	 *            Integer
	 * @param idDireccion
	 *            Integer
	 * @param idDesResAct
	 *            Integer
	 * @return Integer número de registros duplicados.
	 */
	@RequestMapping(value = "/registroDuplicado/{idOrigen}/{idDireccion}/{idDesResAct}", method = RequestMethod.GET)
	public @ResponseBody Integer registroDuplicado(@PathVariable Integer idOrigen, @PathVariable Integer idDireccion,
			@PathVariable Integer idDesResAct) {

		ResultadosActuacion resultadoActuacion = new ResultadosActuacion();
		resultadoActuacion.setIdOrigen(idOrigen);
		resultadoActuacion.setIdDireccion(idDireccion);
		resultadoActuacion.setDesResAct(new DesResAct(idDesResAct));

		return this.resultadosActuacionService.findRegistroDuplicado(resultadoActuacion);
	}

	/**
	 * Mï¿½todo que genera una hoja de excel con los resultados de bï¿½squeda de
	 * resultadosActuacion.
	 */
	@RequestMapping(value = { "/exportarExcel/{sidx}/{sord}" }, method = RequestMethod.POST)
	public void getExcel(@ModelAttribute ResultadosActuacion filterResAct, @PathVariable String sidx,
			@PathVariable String sord, @ModelAttribute TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		try {
			List<ResultadosActuacion> listaResultadosActuacion;

			tableRequestDto.setSidx(sidx);
			tableRequestDto.setSord(sord);

			if (filterResAct.getDireccion() != null && filterResAct.getDireccion().getIdDireccion() != null) {
				if (filterResAct.getDireccion().getIdDireccion().equals("")) {
					filterResAct.getDireccion().setIdDireccion(null);
				}
			}
			if (filterResAct.getIdOrigen() != null) {
				if (filterResAct.getIdOrigen().equals("")) {
					filterResAct.setIdOrigen(null);
				}
			}
			if (filterResAct.getDesResAct() != null && filterResAct.getDesResAct().getIdDesResAct() != null) {
				if (filterResAct.getDesResAct().getIdDesResAct().equals("")) {
					filterResAct.getDesResAct().setIdDesResAct(null);
				}
			}

			listaResultadosActuacion = this.resultadosActuacionService.findAllLike(filterResAct, tableRequestDto,
					false);

			this.resultadosActuacionService.getExcel(listaResultadosActuacion, response);

		} catch (

		Exception e) {
			ResultadosActuacionController.logger.error("[Exportar Excel] ERROR : ", e);
		}
	}
}
